local addonVar = ChatKeys.getVar() -- ///// copie de la locale addonVar pour ce fichier

local panel
local classicMargin = 15
local availableWidth = 622 - (classicMargin * 2)
if (ChatKeys.isRetail()) then
	classicMargin = 0
	availableWidth = 665
end

----------------------------------------------------------------------------------------
------------------------------------- CONSTRUCTION -------------------------------------

function ChatKeys.settingsCreate()
	local margeH = classicMargin + 20
	local subFrame, fontString, chapterString, subChapterString, chkButton
	
	local thisAddon, addonTitle, addonNotes = GetAddOnInfo(addonVar["name"])
	local titleString = panel:CreateFontString(addonVar["settingsPanel"].."_Title", "ARTWORK", "GameFontNormalLarge")
	titleString:SetPoint("TOPLEFT", classicMargin + 5, -(classicMargin + 5))
	titleString:SetText(addonTitle.." v"..ChatKeys.getVersion(false))
	-------------------------- author
	fontString = panel:CreateFontString(addonVar["settingsPanel"].."_Author", "ARTWORK", "GameFontNormalSmall")
	fontString:SetPoint("LEFT", titleString, "RIGHT", 80, -1)
	fontString:SetTextColor(0.5, 0.5, 0.9, 1)
	fontString:SetText("Copyright "..GetAddOnMetadata(ChatKeys.getVar("name"), "Author"))
	-------------------------- infos/notes
	local infosFrame = ChatKeys.createTextFrame(nil, panel, availableWidth - (margeH * 2), addonNotes, 0)
	infosFrame:SetPoint("TOPLEFT", titleString, "BOTTOMLEFT", margeH, -5)
	ChatKeys.setFontStyle(infosFrame.font, nil, 12, "#AAAABB", false, nil)
	-------------------------- chapitre ami et chans
	chapterString = ChatKeys.settingsSetChapterTitle(ChatKeys.getLocal("Friend and channels definition"))
	chapterString:SetPoint("TOPLEFT", infosFrame, "BOTTOMLEFT", -margeH, -25)
	-------------- ami
	subChapterString = ChatKeys.settingsSetChapterTitle(ChatKeys.getLocal("The defined key allows to whisper to this player"), 10, "#AAAAAA")
	subChapterString:SetPoint("TOPLEFT", chapterString, "BOTTOMLEFT", margeH, -10)
	subFrame = ChatKeys.settingsSetDefineChannel(ChatKeys.getLocal("Your (girl/boy)friend's name:"), "Ck_cfg_friendDef")
	subFrame:SetPoint("TOPLEFT", chapterString, "BOTTOMLEFT", margeH * 2, -20)
	-------------- chans
	subChapterString = ChatKeys.settingsSetChapterTitle(ChatKeys.getLocal("Defined keys start a message on these channels"), 10, "#AAAAAA")
	subChapterString:SetPoint("TOPLEFT", subFrame, "BOTTOMLEFT", -margeH, -10)

	local subFrame1 = ChatKeys.settingsSetDefineChannel(ChatKeys.getLocal("Custom channel's name #1:"), "Ck_cfg_chan1")
	subFrame1:SetPoint("TOPLEFT", subChapterString, "BOTTOMLEFT", margeH, -2)

	local subFrame2 = ChatKeys.settingsSetDefineChannel(ChatKeys.getLocal("Custom channel's name #2:"), "Ck_cfg_chan2")
	subFrame2:SetPoint("TOPLEFT", subFrame1, "BOTTOMLEFT", 0, 4)

	local subFrame3 = ChatKeys.settingsSetDefineChannel(ChatKeys.getLocal("Custom channel's name #2:"), "Ck_cfg_chan3")
	subFrame3:SetPoint("TOPLEFT", subFrame2, "BOTTOMLEFT", 0, 4)

	-------------------------- chapitre connected chans
	chapterString = ChatKeys.settingsSetChapterTitle(ChatKeys.getLocal("Connected channels:"))
	chapterString:SetPoint("TOPLEFT", subFrame3, "BOTTOMLEFT", -(margeH * 2), -15)
	----------- chans perso gauche
	fontString = panel:CreateFontString("Ck_cfg_connectedChans_L", "ARTWORK", "GameFontNormal")
	fontString:SetPoint("TOPLEFT", chapterString, "BOTTOMLEFT", margeH * 2, -5)
	fontString:SetJustifyH("LEFT")
	----------- chans perso droite
	fontString = panel:CreateFontString("Ck_cfg_connectedChans_R", "ARTWORK", "GameFontNormal")
	fontString:SetPoint("TOPLEFT", chapterString, "BOTTOMLEFT", 300, -5)
	fontString:SetJustifyH("LEFT")

	------------------------- checkBoxes
	----------- sons
	chkButton = ChatKeys.createStandardCheckBox("Ck_cfg_sound_Chk", panel, ChatKeys.getLocal("Play sound when receiving whisper"))
	chkButton:SetPoint("TOPLEFT", chapterString, "BOTTOMLEFT", 0, -80)
	chkButton:SetScript("OnClick", function(self)
		CK_SAVED["sndNotification"] = ChatKeys.booleanToInt(self:GetChecked())
	end)
	----------- group number
	chkButton = ChatKeys.createStandardCheckBox("Ck_cfg_partyNum_Chk", panel, ChatKeys.getLocal("Display party numbers on raid channel"))
	chkButton:SetPoint("TOPLEFT", Ck_cfg_sound_Chk, "BOTTOMLEFT", 0, -1)
	chkButton:SetScript("OnClick", function(self)
		CK_SAVED["displayPartyNumber"] = ChatKeys.booleanToInt(self:GetChecked())
	end)
	----------- raccourcir préfixes
	chkButton = ChatKeys.createStandardCheckBox("Ck_cfg_prefix_Chk", panel, ChatKeys.getLocal("Shorten chat prefixes"))
	chkButton:SetPoint("TOPLEFT", Ck_cfg_partyNum_Chk, "BOTTOMLEFT", 0, -1)
	chkButton:SetScript("OnClick", function(self)
		CK_SAVED["shortPrefixes"] = ChatKeys.booleanToInt(self:GetChecked())
		if (CK_SAVED["shortPrefixes"] == 1) then
			ChatKeys.shortenGlobalStrings()
		else
			ChatKeys.restoreGlobalStrings()
		end
	end)
	------------------------- cmds
	subFrame = ChatKeys.createTextFrame(nil, panel, availableWidth - margeH, ChatKeys.getLocal("Supported slash-commands:").."\n\n"..
	ChatKeys.slashCmd_showList(true), 15)
	subFrame:SetPoint("TOPLEFT", chkButton, "BOTTOMLEFT", 0, -10)
	ChatKeys.setFontStyle(subFrame.font, nil, 10, "#CCCCCC", false, nil)
	ChatKeys.setRoundBorderedFrame(subFrame, nil, nil, nil)
end

-------------------------------------------------------- FCNs (templates)
function ChatKeys.settingsSetChapterTitle(str, fontSize, fontColor)
	local fontString = panel:CreateFontString(nil, "ARTWORK", "GameFontNormal")
	ChatKeys.setFontStyle(fontString, nil, fontSize or 12, fontColor or "yellow", false, 1)
	fontString:SetText(str)
	return fontString
end

function ChatKeys.settingsSetDefineChannel(label, frameName)
	----------------------- frame ensemble
	local frame = CreateFrame("Frame", frameName, panel)
	frame:SetSize(650, 32)
	----------------------- label
	local fontString = frame:CreateFontString(nil, "ARTWORK", "GameFontNormal")
	fontString:SetPoint("LEFT", frame, 0)
	fontString:SetText(label)
	----------------------- edit text
	local editBox = CreateFrame("EditBox", "$parent_edit", frame, "InputBoxTemplate")
	editBox:SetSize(175, 32)
	editBox:SetPoint("LEFT", fontString, "LEFT", 180, -2)
	editBox:SetMultiLine(false)
	editBox:SetAutoFocus(false)
	editBox:SetTextInsets(4, 2, -1, 0) -- left, right, top, bottom
	editBox:SetMaxLetters(40)
	--editBox:SetHighlightColor(0.38,0.4,0.04)
	editBox:SetScript("OnEditFocusLost", function(self) ChatKeys.updateSaved(frame) end) -- MAJ du texte (Desc) sur perte focus
	editBox:SetScript("OnEscapePressed", function(self) self:ClearFocus() end) -- save
	editBox:SetScript("OnEnterPressed", function(self) self:ClearFocus() end) -- save
	----------------------- rappel binded key
	local bindedKeyStr = frame:CreateFontString(nil, "ARTWORK", "GameFontNormal")
	bindedKeyStr:SetPoint("LEFT", editBox, "RIGHT", 25, 0)
	bindedKeyStr:SetText("")
	----------------------- scripts (fcns)
	frame.value = editBox -- pour update value
	frame.GetValue = function() return editBox:GetText() end
	frame.SetValue = function(self, str) editBox:SetText(str) end -- pour update value
	
	frame.text = bindedKeyStr -- pour update binded key
	frame.GetText = function() return bindedKeyStr:GetText() end
	frame.SetText = function(self, str) bindedKeyStr:SetText(str) end -- pour update binded key
	----------------------- 
	return frame
end

----------------------------------------------------------------------------------------
----------------------------------- UPDATE (onShow) ------------------------------------

function ChatKeys.settingsUpdate()
	Ck_cfg_friendDef:SetValue(ChatKeys.videSiNul(CK_SAVED["buddyName"]))
	Ck_cfg_friendDef:SetText(ChatKeys.getStrBindedKey("CUSTOMMESSAGE"))

	Ck_cfg_chan1:SetValue(ChatKeys.videSiNul(CK_SAVED["channelName1"]))
	Ck_cfg_chan1:SetText(ChatKeys.getStrBindedKey("CUSTOMCHANNEL1"))

	Ck_cfg_chan2:SetValue(ChatKeys.videSiNul(CK_SAVED["channelName2"]))
	Ck_cfg_chan2:SetText(ChatKeys.getStrBindedKey("CUSTOMCHANNEL2"))

	Ck_cfg_chan3:SetValue(ChatKeys.videSiNul(CK_SAVED["channelName3"]))
	Ck_cfg_chan3:SetText(ChatKeys.getStrBindedKey("CUSTOMCHANNEL3"))

	ChatKeys.fillConnectedChansList()

	Ck_cfg_sound_Chk:SetChecked(CK_SAVED["sndNotification"] == 1)
	Ck_cfg_partyNum_Chk:SetChecked(CK_SAVED["displayPartyNumber"] == 1)
	Ck_cfg_prefix_Chk:SetChecked(CK_SAVED["shortPrefixes"] == 1)
end


function ChatKeys.fillConnectedChansList() -- affichage sur 2 colonnes de 5 lignes la liste des canaux connectes
	local colG = "" 
	local colD = ""
	for i = 1, 10, 1 do
		local idCanal, nomCanal = GetChannelName(i)
		if (nomCanal ~= nil) then
			if (strfind(nomCanal, " ", 1, true) ~= nil) then nomCanal = strsub(nomCanal, 1, strfind(nomCanal, " ", 1, true) - 1) end
			if (i <= 5) then
				colG = colG..i.." - "..nomCanal.."\n"
			else
				colD = colD..i.." - "..nomCanal.."\n"
			end
		end;
	end
	Ck_cfg_connectedChans_L:SetText("|cFF00BFF2"..colG)
	Ck_cfg_connectedChans_R:SetText("|cFF00BFF2"..colD)
end

function ChatKeys.updateSaved(editBoxFrame) -- update SAVED d'après edit boxes
	local tbl = {
		["Ck_cfg_friendDef"] = "buddyName",
		["Ck_cfg_chan1"] = "channelName1",
		["Ck_cfg_chan2"] = "channelName2",
		["Ck_cfg_chan3"] = "channelName3",
	}
	local editName = editBoxFrame:GetName()
	CK_SAVED[tbl[editName]] = editBoxFrame:GetValue()
end

function ChatKeys.getStrBindedKey(nomCommande)
	local tKey = ChatKeys.getBindedKey(nomCommande)
	if (tKey ~= nil) then
		return "|cFF8080E6"..tKey
	else
		return "|cFFCC0303"..ChatKeys.getLocal("No binded key")
	end
end

----------------------------------------------------------------------------------------
------------------------- GESTION SETTINGS (ne pas déplacer) ---------------------------

if (panel == nil) then
	panel = CreateFrame("Frame", addonVar["settingsPanel"])

	local background = panel:CreateTexture()
	background:SetAllPoints(panel)
	background:SetColorTexture(0.1, 0.1, 0.1, 0.15)
	ChatKeys.settingsCreate()
	panel:SetScript("OnShow", function(self)
		ChatKeys.settingsUpdate()
	end)
end

if (Settings ~= nil) then -- meilleur test que .isRetail()
	local category = Settings.RegisterCanvasLayoutCategory(panel, addonVar["name"])
	-- OU, pour un panneau scrolling : local category = Settings.RegisterVerticalLayoutCategory(addonVar["name"])
	Settings.RegisterAddOnCategory(category) -- wow10
else
	panel.name = addonVar["name"]
	-- panel.okay = function (self) ChatKeys.settingsValidate() end -- non géré (automatique si wow10)
	-- panel.cancel = function (self) ChatKeys.settingsCancel() end -- non géré (impossible si wow10)
	panel.default = function (self) ChatKeys.settingsDefault() end
	panel.refresh = function (self) ChatKeys.settingsUpdate() end
	InterfaceOptions_AddCategory(panel)
end

function ChatKeys.settingsDefault()
	if (_G[addonVar["settingsPanel"]]:IsVisible()) then -- sinon, ca concerne pas cet addon
		ChatKeys.reset()
	end
end
